Subject: bug#49089: --fallback doesn't do anything when 'connect*' fails

From: Mathieu Othacehe <[email-masked]>
Date: Fri, 18 Jun 2021 17:36:35 +0200

Hello Maxime,

> guix substitute: warning: [...].local: host not found: Naam of dienst is niet bekend
> guix substitute: warning: tijdens het binnenhalen van https://ci.guix.gnu.org/nar/lzip/r8a9kzhhx89rmmkz66i3324acgliqdwa-gdm-3.34.1: de server is een beetje traag
> guix substitute: warning: probeer ‘--no-substitutes’ als het probleem hardnekkig is
> guix substitute: error: connect*: Verbinding is verlopen

There are actually two bugs withing a single one here. The first one is
that you could not connect to the berlin publish server in less than 5
seconds (the timeout duration).

I have already observed such problems on the build farm and reported it
here: https://issues.guix.gnu.org/48468. It has been mitigated by
implementing keep-alive support[1]. However, I suppose that the
underlying issue is that guix-publish is in some cases over-flood and
fails to accept new connections.

> As I specified the --fallback option, I would expect guix to start
> building from source, as the substitution failed.

The second issue is that as you noticed, the fallback option doesn't
have any effect.

Thanks,

Mathieu

[1]: https://issues.guix.gnu.org/48556